/*
The DsTool program is the property of:
 
                             Cornell University 
                        Center of Applied Mathematics 
                              Ithaca, NY 14853
                      dstool_bugs@macomb.tn.cornell.edu
 
and may be used, modified and distributed freely, subject to the following
restrictions:
 
       Any product which incorporates source code from the DsTool
       program or utilities, in whole or in part, is distributed
       with a copy of that source code, including this notice. You
       must give the recipients all the rights that you have with
       respect to the use of this software. Modifications of the
       software must carry prominent notices stating who changed
       the files and the date of any change.
 
DsTool is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of FITNESS FOR A PARTICULAR PURPOSE.
The software is provided as is without any obligation on the part of Cornell 
faculty, staff or students to assist in its use, correction, modification or
enhancement.
*/

/* 
 * iterate.h
 */

#ifndef ITERATE_HEADER
#define ITERATE_HEADER

#include "complib.h"
#include "manifold.h"

#define	STEP_FORW	1.0
#define	STEP_BACK      -1.0

#define	MEM_FAILURE 	-1
#define DIVERGENCE	-2
#define STOP_NOTIFY	-3
#define NO_CONVERGENCE  -4
#define SINGULAR	-5
#define DIV_BY_ZERO	-6

int iter_forw( int (*f)(double [], double [], double []),
	      int k, double *y, double *x, double *p,
	      int ph_sp_dim, double time_step, double *v,
	      Manifold *manifold);

int iterate(struct Prop_DataS *iter_cntl);

#endif
